export default function (context) {
  return {
    /**
     * 返回要定制的自定义字段组件信息，不需要定制return null
     *
     comInfo: {
                name: "cmpt1",//（必须）自定义字段组件的名称，根目录config.json文件中components节点中指向对应组件的key
                prop: {test: 1}//会透传到自定义字段组件customProp属性，格式不限。
            }
     * @return {Object}
     */
    customFieldCom({field}) {
      let comInfo = null;
      if (field && field.api_name === 'field_testplugin__c') {
        console.log("test plugin: customFieldCom: " + field.api_name)
        comInfo = {
          name: "cmpt1",
          prop: {test: 1}
        }
      }
      return Promise.resolve(comInfo)//异步return
      //return comInfo //或者直接同步return
    },

    /**通用按钮处理*/
    beforeNormalButtonsRender({buttons}) {
      buttons&&buttons.some(it=>{
        if(it.api_name==="button_testplugin__c"){
          it.onClick=function (){
            context.emitEvent("show-dialog1", {test:654987})
          }
          return true;
        }
      })
      return Promise.resolve(buttons)
    },

    /**渲染fixed组件*/
    renderFixedCom(){
      return [{
        name: "dialog1",
        prop: {test: 1}
      }]
    },

    /**form页渲染完成*/
    renderEnd() {
      console.log("test plugin: renderEnd")
      wx.showModal({
        content: "插件拦截renderEnd",
        showCancel: false
      })
    },
    /**提交前触发， resovle之后继续提交流程*/
    beforeSubmit(opt) {
      console.log("test plugin: beforeSubmit")
      return new Promise(resolve => {
        wx.showModal({
          title: "插件拦截提交",
          content: "是否提交？",
          showCancel: true,
          success(rst) {
            if (rst.confirm) {
              resolve(opt)
            }
          }
        })
      })
    },
    /**提交成功后触发， resovle之后继续提交后动作*/
    submitted(opt) {
      console.log("test plugin: submitted")
      return new Promise(resolve => {
        wx.showModal({
          title: "插件拦截提交后动作",
          content: "是否继续？",
          showCancel: true,
          success(rst) {
            if (rst.confirm) {
              resolve(opt)
            }
          }
        })
      })
    }
  }
}
